// Copyright (c) 2021 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include <stdint.h>
#include <memory.h>
#include "../display/shader.h"
#include "../display/spritebatch.h"
#include "tile.h"

#define CHUNK_WIDTH 3
#define CHUNK_HEIGHT CHUNK_WIDTH
#define CHUNK_DEPTH CHUNK_HEIGHT

typedef struct {
  /** Absolute X Y Z chunklist coordinates */
  int32_t x, y, z;

  /** Sprite Batch for holding static tiles */
  spritebatch_t *batch;
} chunk_t;


/**
 * Initializes a chunk for the first time.
 * 
 * @param chunk Pointer to the chunk to initialize.
 */
void chunkCreate(chunk_t *chunk);

/**
 * Render a given chunk.
 * 
 * @param chunk Chunk to render
 * @param
 */
void chunkRender(chunk_t *chunk, shader_t *shader);